﻿601,100
562,"NULL"
586,
585,
564,
565,"fsr\KtaUQQ=e5fl4ZvdZcOO@Z389g1?M;S[i2qJNRGMh^??LMR0IgKcI3A\6[BKStTO_EOwQz=uFB87\a>zJ6jHZqog^OE:s9Kkw9\6;s>WSeH4fIzfxWO0JjleJ;GJ];;f:mmS_cfq=Yt[Tb^5<IJ?COohaENaW8QE^2;JwoWnX2CP2Aohm`kR6Nm7WH]QnOFqugpY="
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,3
pExecutionId
pAppId
pVersion
561,3
2
2
2
590,3
pExecutionId,"None"
pAppId,"MyApp"
pVersion,"9.5.2"
637,3
pExecutionId,
pAppId,
pVersion,
577,0
578,0
579,0
580,0
581,0
582,0
572,44


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2010
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


### Add element: TakeOwnershipNode
cNodeInfoDim = '}tp_node_info';

If (DimensionExists(cNodeInfoDim) = 0);
ProcessError;
EndIf;

cTakeOwnershipNode = 'TakeOwnershipNode';
cStartEditingDate = 'StartEditingDate';
If (DIMIX(cNodeInfoDim, cTakeOwnershipNode) = 0);
DimensionElementInsert(cNodeInfoDim, cStartEditingDate, cTakeOwnershipNode, 'S');
EndIf;

### Add attribute: Version
cApplicationsDim = '}tp_applications';
cApplicationsAttributesDim = '}ElementAttributes_' | cApplicationsDim;

If (DimensionExists(cApplicationsDim) = 0 % DimensionExists(cApplicationsAttributesDim) = 0);
ProcessError;
EndIf;

cApprovalDimensionAttr = 'ApprovalDimension';
cVersionAttr = 'Version';
If (DIMIX(cApplicationsAttributesDim, cVersionAttr) = 0);
AttrInsert(cApplicationsDim, cApprovalDimensionAttr, cVersionAttr, 'S');
EndIf;

573,1

574,1

575,152


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2010
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


### Set value to version attribute
If (DIMIX(cApplicationsDim, pAppId) = 0);
ProcessError;
EndIf;

AttrPutS(pVersion, cApplicationsDim, pAppId, cVersionAttr);

cTM1Process = '}tp_update_state_cube';

### Get Approval dimension and subset

#* declare global variables
StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');

vReturnValue = ExecuteProcess('}tp_get_application_attributes', 
'pExecutionId', pExecutionId,
'pAppId', pAppId, 
'pControl',  'Y');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cApprovalDim = gApprovalDim;
cApprovalSubset = gApprovalSubset;

If (DimensionExists(cApprovalDim) = 0);
ProcessError;
EndIf;


### Write taking ownership nodes 
cStateCube = '}tp_application_state}' | pAppId;
If (CubeExists(cStateCube) = 0);
ProcessError;
EndIf;

cCurrentOwner = 'CurrentOwner';
cTakeOwnershipNode = 'TakeOwnerShipNode';

cApprovalDimSize = DIMSIZ(cApprovalDim);
vIndex = 1;
While (vIndex <= cApprovalDimSize);
vNode = DIMNM(cApprovalDim, vIndex);

vCurrentOwnerValue = CellGetS(cStateCube, vNode, cCurrentOwner);
vTakeOwnershipNode = CellGetS(cStateCube, vNode, cTakeOwnershipNode);
If (vCurrentOwnerValue @<> '' & vTakeOwnershipNode @= '');
	If (CellIsUpdateable(cStateCube, vNode, cTakeOwnershipNode) = 0);
		vDetail=INSRT(cTakeOwnershipNode,')',1);
		vDetail=INSRT(',',vDetail,1);
		vDetail=INSRT(vNode,vDetail,1);
		vDetail=INSRT('(',vDetail,1);
		vDetail=INSRT(cStateCube,vDetail,1);
		vReturnValue = ExecuteProcess('|tp_error_update_error_cube', 
		'pGuid', pExecutionId, 
		'pProcess', cTM1Process, 
		'pErrorCode', 'TI_APPLICATION_NOT_UPDATEABLE',
		'pErrorDetails', vDetail,
		'pControl', 'Y');
		ProcessError;
	EndIf;
	CellPutS(vNode, cStateCube, vNode, cTakeOwnershipNode);
EndIf;

vIndex = vIndex + 1;
End;

### Create "everyone" group

cSystemConfigDim = '}tp_system_config';
If (DimensionExists(cSystemConfigDim) = 0);
ProcessError;
EndIf;

cSecurityModeNode = 'IntegratedSecurityMode';
cConfigValueAttr = 'ConfigValue';
vSecurityMode = ATTRS(cSystemConfigDim, cSecurityModeNode, cConfigValueAttr);

cCognosEveryoneGroup = 'CAMID("::Everyone")';
cTpEveryoneGroup = '}tp_Everyone';
If (vSecurityMode @= '5');

If (DIMIX('}Groups', cCognosEveryoneGroup) = 0);
ProcessError;
EndIf;

If (DIMIX('}Groups', cTpEveryoneGroup) <> 0);
DeleteGroup(cTpEveryoneGroup);
EndIf;

cEveryoneGroup = cCognosEveryoneGroup;

Else;

cEveryoneGroup = cTpEveryoneGroup;

If (DIMIX('}Groups', cEveryoneGroup) = 0);
AddGroup(cEveryoneGroup);
EndIf;

EndIf;

### Give everyone access to process: }tp_workflow_submit_leaf_children

sProcessesDim = '}Processes';
sProcessSecurityCube = '}ProcessSecurity';
If (CubeExists(sProcessSecurityCube) = 0);

CubeCreate(sProcessSecurityCube, sProcessesDim, '}Groups');
CubeSetLogChanges(sProcessSecurityCube, 1);
EndIf;

cSubmitLeafChildrenProc = '}tp_workflow_submit_leaf_children';
If (DIMIX(sProcessesDim, cSubmitLeafChildrenProc) = 0);
	ProcessError;
Else;
	If (CellIsUpdateable(sProcessSecurityCube, cSubmitLeafChildrenProc, cEveryoneGroup) = 0);
		vDetail=INSRT(cEveryoneGroup,')',1);
		vDetail=INSRT(',',vDetail,1);
		vDetail=INSRT(cSubmitLeafChildrenProc,vDetail,1);
		vDetail=INSRT('(',vDetail,1);
		vDetail=INSRT(sProcessSecurityCube,vDetail,1);
		vReturnValue = ExecuteProcess('}tp_error_update_error_cube', 
		'pGuid', pExecutionId, 
		'pProcess', cTM1Process, 
		'pErrorCode', 'TI_SEMAPHORE_NOT_UPDATEABLE',
		'pErrorDetails', vDetail,
		'pControl', 'Y');
		ProcessError;
	EndIf;
	CellPutS('Read', sProcessSecurityCube, cSubmitLeafChildrenProc, cEveryoneGroup);
EndIf;


576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
